; supatch1/asm - kjw/bqsd - 02/83
;
; revised 03/28/83 - kjw
;
	TITLE		'<Patch File Mod I>'
;
;	program equates
;
PATCHES	EQU	0D218H		;start patch area
PATCH	DEFL	PATCHES		;label for patches
TEMP1	EQU	4050H		;temp storage 1
TEMP5	EQU	4058H		;temp storage 5
;
;	** Patch 1 ** 03/28/83 ** kjw/rbr **
;
; Correct incorrect placement of user track count
; from the 'use configuration' prompt in formatting
;
	ORG	9070H
PATCH1	DEFB	00		;(IY+1) => (IY+0)
;
;	** Patch 2 ** 03/28 83 ** kjw/rbr **
;
; Correct invalid calculation of GAT table bytes
; on double sided dosplus diskettes
;
	ORG	8E3CH
PATCH2	DEFB	00,00,00	;LD A,(IY+7)
	DEFB	00,00		;CP 7
	DEFB	00,00		;JR C,MNYGRN3
	DEFB	00,00		;CP 10
	DEFB	00,00		;JR C,MNYGRN1
;
;	** Patch 3 ** 03/28/83 ** kjw/rbr **
;
; Improve disk end detection during formatting
;
	ORG	91A4H
PATCH3	DEFB	30H		;JR Z => JR NC
;
;	** Patch 4 ** 03/28/83 ** kjw/rbr **
;
; Corrects format without erase using R specifier
;
	ORG	9143H
PATCH4	DEFB	00,00		;AND 0E7H
	CALL	PATCH4A		;execute patch
;
	ORG	91ADH
	CALL	PATCH4B		;restore saved config
;
	ORG	PATCH
PATCH4A	PUSH	AF		;save unmasked A
	AND	0E7H		;reset rel sectoring
	LD	(IY+6),A	;update DCT
	LD	A,(IY+8)	;highest sector 0
	LD	(TEMP5),A	;save it
	LD	A,(IY+9)	;highest sector disk
	LD	(TEMP5+1),A	;save it
	POP	AF		;restore config
	BIT	3,A		;relative engaged?
	RET	Z		;nope, go!
	BIT	7,(IY+6)	;double den track 0?
	CALL	PATCH4C		;load 10/18
	LD	(IY+8),A	;highest sector 0
	BIT	6,(IY+6)	;double den disk?
	CALL	PATCH4C		;load 10/18
	LD	(IY+9),A	;highest sector disk
	RET			;continue!
;
PATCH4C	LD	A,9		;highest sector single
	RET	Z		;go if single
	LD	A,17		;highest sector double
	RET			;go double
;
PATCH4B	LD	A,(TEMP5)	;get saved config
	LD	(IY+8),A	;save it
	LD	A,(TEMP5+1)	;second part
	LD	(IY+9),A	;save it
	LD	A,(TEMP1)	;get saved config
	RET			;continue!
PATCH	DEFL	$		;next patch address
;
;	** Patch 5 ** 03/28/83 ** kjw/rbr **
;
; Correct directory length computation during format
;
	ORG	9304H
PATCH5	CALL	PATCH5A		;CALL GETDIR
;
	ORG	PATCH
PATCH5A	CALL	54E9H		;CALL $GETDIR
	DEC	A		;adjust for compare
	RET			;return new value
PATCH	DEFL	$		;next patch
;
;	** Patch 6 ** 03/28/83 ** kjw/rbr **
;
; Resets 'continuous' mode after all operations
;
	ORG	5A1BH
PATCH6	CALL	PATCH6A		;CALL TASKDRV
;
	ORG	PATCH
PATCH6A	CALL	5F02H		;CALL $INITBAD
	JP	6363H		;JP $TASKDRV
PATCH	DEFL	$		;next patch
;
;	** Patch 7 ** 03/28/83 ** kjw/rbr **
;
; Informational patch on Backup using R specifier
;
;	** Patch 8 ** 03/28/83 ** kjw/rbr **
;
; Corrects configuration O/F parameters if both used
;
	ORG	0CEA5H
PATCH8	CALL	PATCH8A		;new code
;
	ORG	PATCH
PATCH8A	LD	A,(DE)		;get string value
	CP	0DH		;terminator?
	RET	Z		;yes, go!
	CP	' '		;separator?
	JR	Z,PATCH8B	;go if yes
	CP	','		;separator?
	RET	NZ		;nope, resume
PATCH8B	EX	(SP),HL		;put HL on stack
	POP	HL		;dummy pop call address
	JP	0CEACH		;continue parse
PATCH	DEFL	$		;next patch
;
	END	0000H
